<?php

namespace Andrew\ModeratorPanel\XF\Repository;

use XF\Mvc\Entity\Finder;
use XF\Mvc\Entity\Repository;

class User extends XFCP_User
{
    public function warningPoints($userId)
    {
        $db = \XF::db();
        $warning_points = $db->fetchRow('select xf_user.user_id, xf_user.username, xf_user.message_count, count(xf_warning.warning_id) as warning_count, xf_user.warning_points as active_points, sum(xf_warning.points) total_points
                                    from xf_user
                                    inner join xf_warning on xf_user.user_id = xf_warning.user_id
                                    where xf_user.user_id = ?
                                    group by xf_user.user_id, xf_user.username, xf_user.message_count, xf_user.warning_points
                                    having sum(xf_warning.warning_id) > 0
                                    order by warning_count desc',$userId);

        return $warning_points;
    }
    public function reportCount($userId)
    {
        $db = \XF::db();
        $report_count = $db->fetchRow("select xf_user.user_id, xf_user.username, xf_user.message_count, xf_user.warning_points, sum(xf_report.report_count) as report_count
                                    from xf_user
                                    inner join xf_report on xf_user.user_id = xf_report.content_user_id
                                    where xf_user.user_id = ?
                                    group by xf_user.user_id, xf_user.username, xf_user.message_count, xf_user.warning_points
                                    having sum(xf_report.report_id) > 0
                                    order by report_count DESC",$userId);

        return $report_count;
    }
}